#if HAVE_CONFIG_H
#include "config.h"
#endif

#include <sys/types.h>
#include <sys/ptrace.h>
#include <sys/param.h>
#include <sys/user.h>
#include <stdio.h>

#include "ltrace.h"

void * get_instruction_pointer(struct process *proc)
{
	return (void *)md_fetch_eip(proc->pid);
}

void set_instruction_pointer(struct process *proc, void *addr)
{
	md_store_eip(proc->pid, addr);
}

void * get_stack_pointer(struct process *proc)
{
	return (void *)md_fetch_esp(proc->pid);
}

void * get_return_addr(struct process *proc, void * stack_pointer)
{
	return (void *)ptrace(PT_READ_I, proc->pid, stack_pointer, 0);
}
